package com.learnweblogic.examples.ch9.cmp;

import java.io.Serializable;

public final class BookPK implements Serializable {

  public int copyNumber;
  public String isbn;

  public BookPK() {}

  public BookPK(String isbn, int copyNumber) {
    this.copyNumber = copyNumber;
    this.isbn       = isbn;
  }

  public int hashCode() {
    return copyNumber ^ isbn.hashCode();
  }

  public boolean equals(Object o) {

    if (o instanceof BookPK) {
      BookPK other = (BookPK) o;

      return other.copyNumber == copyNumber &&
        other.isbn.equals(isbn);
    } else {
      return false;
    }
  }

  public String toString() {
    return "[BookPK] copyNumber: "+copyNumber+ " isbn: "+isbn;
  }

}
