package com.learnweblogic.examples.ch9.cmp;


import java.util.Collection;

import javax.ejb.EntityContext;
import javax.ejb.EntityBean;

public abstract class StudentCMPBean implements EntityBean {

  private EntityContext ctx;

  public abstract String getName();
  public abstract void setName(String n);

  public abstract Integer getSsn();
  public abstract void setSsn(Integer ssn);

  public abstract int getGrade();
  public abstract void setGrade(int gr);

  public abstract Locker getLocker();
  public abstract void setLocker(Locker l);

  public abstract Collection getBooks();
  public abstract void setBooks(Collection b);

  public abstract Collection getTeachers();
  public abstract void setTeachers(Collection t);

  public void setEntityContext(EntityContext c) {
    ctx = c;
  }

  public void unsetEntityContext() {
    ctx = null;
  }


  public Integer ejbCreate(String name, int ssn, int grade)
  {
    setName(name);
    setSsn(new Integer(ssn));
    setGrade(grade);
    
    return null;
  }

  // This implementation requires no post-create initialization so
  // this required method is empty
  public void ejbPostCreate(String name, int ssn, int grade) {}


  // These methods are required by the EntityBean interface but are
  // not used in this implementation.

  public void ejbRemove() {}

  public void ejbLoad() {}

  public void ejbStore() {}

  public void ejbActivate() {}
  public void ejbPassivate() {}

  public void assignLocker(Locker l) {
    setLocker(l);
  }

  public void assignBook(Book b) {
    Collection books = getBooks();
    books.add(b);
  }

  public void assignTeacher(Teacher t) {
    Collection teachers = getTeachers();
    teachers.add(t);
  }

}


