package com.learnweblogic.examples.ch3;

import javax.servlet.*;
import javax.servlet.http.*;

public class OnlyDsFilter implements Filter {
    
    FilterConfig config = null;
    
    public void doFilter(javax.servlet.ServletRequest req, javax.servlet.ServletResponse res, javax.servlet.FilterChain chain) 
    throws java.io.IOException, javax.servlet.ServletException {
        if(req instanceof HttpServletRequest && res instanceof HttpServletResponse) {
            HttpServletRequest httpReq = (HttpServletRequest)req;
            HttpServletResponse httpRes = (HttpServletResponse)res;
            String user = httpReq.getRemoteUser();
            if(null != user && !user.startsWith("D")) {
                httpRes.sendError(HttpServletResponse.SC_FORBIDDEN, "Only D users allowed");
                return;
            }
        }
        chain.doFilter(req, res);
        return;
    }
    
    public void init(javax.servlet.FilterConfig filterConfig) throws javax.servlet.ServletException {
        config = filterConfig;
    }
    
    public void destroy() {
    }
}
