package com.learnweblogic.examples.ch7.topic;

import com.learnweblogic.examples.BaseClient;

import javax.jms.JMSException;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.jms.Topic;
import javax.jms.TopicConnection;
import javax.jms.TopicConnectionFactory;
import javax.jms.TopicSession;
import javax.jms.TopicSubscriber;
import javax.naming.Context;
import javax.naming.NamingException;

public final class SyncMessageConsumer extends BaseClient {

    private TopicSubscriber subscriber;
    private TextMessage msg;

    public SyncMessageConsumer(String[] argv)
        throws JMSException, NamingException {
        super(argv);

        Context ctx = getInitialContext();

        TopicConnectionFactory tConFactory =
            (TopicConnectionFactory) ctx.lookup(
                "weblogic.jms.ConnectionFactory");

        Topic messageTopic = (Topic) ctx.lookup("MessageTopic");

        TopicConnection tCon = tConFactory.createTopicConnection();

        TopicSession session =
            tCon.createTopicSession(false, /* not a transacted session */
        Session.AUTO_ACKNOWLEDGE);

        subscriber = session.createSubscriber(messageTopic);

        tCon.start();

    }

    public void runClient() throws JMSException {

        msg = (TextMessage) subscriber.receive();

        System.err.println("Received: " + msg.getText());

        msg = (TextMessage) subscriber.receive();

        System.err.println("Received: " + msg.getText());

    }

    public static void main(String[] argv) throws Exception {
        SyncMessageConsumer consumer = new SyncMessageConsumer(argv);

        consumer.runClient();

    }

}
