package com.learnweblogic.examples.ch8.helloworld;

import com.learnweblogic.examples.BaseClient;

import javax.naming.Context;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;

public final class HelloWorldClient extends BaseClient {

  private Context ctx;

  HelloWorldClient(String [] argv) 
    throws NamingException
  {
    super(argv);

    ctx = getInitialContext();

  }

  public void runClient() 
    throws Exception
  {
    
    HelloWorldHome home = null;

    try {
      Object h = ctx.lookup("HelloWorldEJB");

      home = (HelloWorldHome)
        PortableRemoteObject.narrow(h, HelloWorldHome.class);
    } catch (NamingException ne) {
      System.err.println("Unable to lookup the HelloWorld EJB.");
      System.err.println("Please make sure that the bean has been deployed"+
        ", and the client's classpath has been set correctly.");

      throw ne;
    }

    try {
      HelloWorld hw = home.create();

      System.out.println("Say Hello to EJB.");

      String ejbSays = hw.helloWorld();

      System.out.println("The EJB said: "+ejbSays);
    } catch (Exception e) {
      System.err.println("Received an unexpected exception " + e
        + " while using the HelloWorldEJB.");

      throw e;
    }
  }

  public static void main(String[] argv) 
    throws Exception
  {
    HelloWorldClient hwc = new HelloWorldClient(argv);

    hwc.runClient();

  }
}

