package com.learnweblogic.examples.ch10.customer;

import javax.ejb.EntityBean;
import javax.ejb.EntityContext;

public abstract class CustomerBean implements EntityBean {

    // Container-managed fields

    // primary key field
    public abstract Integer getId();
    public abstract void setId(Integer id);

    public abstract String getFirstName();
    public abstract void setFirstName(String firstName);

    public abstract String getLastName();
    public abstract void setLastName(String lastName);

    public abstract String getEmailAddress();
    public abstract void setEmailAddress(String email);

    private EntityContext ctx;

    public void setEntityContext(EntityContext c) {
        ctx = c;
    }

    public void unsetEntityContext() {
        ctx = null;
    }

    public Integer ejbCreate(
        Integer id,
        String firstName,
        String lastName,
        String emailAddress) {
        setId(id);
        setFirstName(firstName);
        setLastName(lastName);
        setEmailAddress(emailAddress);

        return null;
    }

    public void ejbPostCreate(
        Integer id,
        String firstName,
        String lastName,
        String emailAddress) {
        // This bean does no ejbPostCreate intialization
    }

    public void ejbRemove() {
    }

    public void ejbActivate() {
    }
    public void ejbPassivate() {
    }

    public void ejbLoad() {
    }
    public void ejbStore() {
    }

}
