package webauction.ejb;

import java.rmi.RemoteException;

import javax.ejb.EJBException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;

public abstract class BidBean implements EntityBean {

    private EntityContext ctx;

    // Container-Managed Fields
    public abstract Integer getId();
    public abstract void setId(Integer id);

    public abstract double getAmount();
    public abstract void setAmount(double am);

    public abstract Item getItem();
    public abstract void setItem(Item item);

    public abstract User getUser();
    public abstract void setUser(User u);

    public void setEntityContext(EntityContext c) {
        ctx = c;
    }

    public void unsetEntityContext() {
        ctx = null;
    }

    public Integer ejbCreate(Integer id, Item item, User user, double amount) {
        setId(id);
        setAmount(amount);
        return null;
    }

    public void ejbPostCreate(
        Integer id,
        Item item,
        User user,
        double amount) {
        // Container-Managed Relationships must be set in the ejbPostCreate
        setItem(item);
        setUser(user);

        try {
            if (item.getTopBidAmount() < amount) {
                item.setTopBidAmount(amount);
            }
        } catch (RemoteException re) {
            throw new EJBException(re);
        }
    }

    public void ejbActivate() {}
    public void ejbPassivate() {}
    public void ejbLoad() {}
    public void ejbStore() {}
    public void ejbRemove() {}

}
