package webauction.ejb;

import java.rmi.RemoteException;
import java.sql.Date;
import java.util.Collection;

import javax.ejb.CreateException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;


public abstract class ItemBean implements EntityBean {

  private EntityContext ctx;

  public abstract Integer getId();
  public abstract void setId(Integer id);

  public abstract User getUser();
  public abstract void setUser(User u);

  public abstract String getDescription();
  public abstract void setDescription(String des);

  public abstract String getCategory();
  public abstract void setCategory(String cat);

  public abstract Date getAuctionEnd();
  public abstract void setAuctionEnd(Date date);

  public abstract double getTopBidAmount();
  public abstract void setTopBidAmount(double a);

  public abstract Collection getBids();
  public abstract void setBids(Collection c);

  public void setEntityContext(EntityContext c) {
    ctx = c;
  }

  public void unsetEntityContext() {
    ctx = null;
  }

  public Integer ejbCreate(Integer id, User user, String description, String
    category, Date endDate) 
    throws CreateException, RemoteException
  {
    setId(id);
    setTopBidAmount(0.0);

    return null;
  }

  public void ejbPostCreate(Integer id, User user, String description, 
    String category, Date d) 
  {
    setUser(user);
    setDescription(description);
    setCategory(category);
    setAuctionEnd(d);
  }

  public void ejbActivate() {}
  public void ejbPassivate() {}

  public void ejbLoad() {}
  public void ejbStore() {}

  public void ejbRemove() {}
  

}




