package webauction.ejb;

import javax.mail.Message;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.InternetAddress;

public final class MailSender {

  private Session mailSession;


  public MailSender(Session session) { 
    mailSession = session;
  }

  public void sendMailMessage(String destAddress, 
    String returnAddress, String subject, String body)
    throws Exception
  {
    Message msg = new MimeMessage(mailSession);
    
    InternetAddress dest = new InternetAddress(destAddress);

    msg.setFrom(new InternetAddress(returnAddress));

    msg.setSubject(subject);
        
    msg.setRecipient(Message.RecipientType.TO, dest);

    msg.setContent(body, "text/plain");
    
    Transport.send(msg);
  }



}
