<jsp:root
  xmlns:jsp="http://java.sun.com/JSP/Page"
  xmlns:input="http://jakarta.apache.org/taglibs/input-1.0"
  xmlns:vtag="http://www.beasys.com/j2ee/tlds/wl-jspvalidationtaglibrary_1_0.tld"
  xmlns:c="http://java.sun.com/jstl/core"
>
  <jsp:directive.page session="false" errorPage="error.jsp"/>

  <jsp:useBean id="item" scope="request" class="webauction.ejb.ItemValueHolder" />

  <jsp:useBean id="bid" scope="request" class="webauction.ejb.BidValueHolder" >
    <jsp:setProperty name="bid" property="bidAmount" />
    <jsp:setProperty name="bid" property="itemId" value="%=item.getId()%"/>
  </jsp:useBean>

  <vtag:summary name="errorSummary">
    <c:if test="${!empty errorSummary}">
      <p>Sorry, we were unable to process your bid as entered. Please 
        correct the issues listed below:</p>
      <c:forEach var="error" items="${errorSummary}">
        <c:out value="${error}"/><br/>
      </c:forEach>
    </c:if>
    <vtag:form method="post" action='SubmitBid'>
      <input:hidden name="id"/>
      <table>
        <tr> 
          <td>Item Description</td>
          <td>
            <jsp:getProperty name="item" property="itemDescription"/>
          </td>
        </tr>
        <tr> 
          <td>Current Top Bid</td>
          <td>
            <jsp:getProperty name="item" property="topBidAmount"/>
          </td>
        </tr>
        <tr>
          <td>Bid Amount:</td>
          <td>
            <input:text name="bidAmount" attributesText='size="10"'/>
            <vtag:validator 
              fieldToValidate="bidAmount"
              expression="0"
              validatorClass="webauction.web.helpers.ValidateNumberGreaterThan"
              errorMessage="Bid must be numeric value greater than 0." />
          </td>
        </tr>
        <tr> 
          <td colspan="2"><input type="submit" value="Submit Bid" name="Submit"/></td>
        </tr>
      </table>
    </vtag:form>
  </vtag:summary>
</jsp:root>