<jsp:root
  xmlns:jsp="http://java.sun.com/JSP/Page"
  xmlns:vtag="http://www.beasys.com/j2ee/tlds/wl-jspvalidationtaglibrary_1_0.tld"
  xmlns:input="http://jakarta.apache.org/taglibs/input-1.0"
  xmlns:c="http://java.sun.com/jstl/core"
>

  <jsp:directive.page session="false" errorPage="error.jsp"/>

  <jsp:useBean id="itembean" scope="request" 
      class="webauction.web.javabean.NewItemBean">
    <jsp:setProperty name="itembean" property="description" />
    <jsp:setProperty name="itembean" property="category" />
    <jsp:setProperty name="itembean" property="endTime" />
  </jsp:useBean>
  <vtag:summary name="errorSummary">
    <c:choose>
      <c:when test="${!empty errorSummary}">
        <p>We didn't get all the fields we need. Provide the following fields 
          so that we can post your item:</p>
        <c:forEach var="error" items="${errorSummary}">
          <c:out value="${error}"/><br/>
        </c:forEach>
      </c:when>
      <c:otherwise>
        <p>Put an item up for auction</p>
      </c:otherwise>
    </c:choose>
    <br/>

    <vtag:form method="POST" name="newitem" action="CreateItem">
      <table>
        <tr>
          <td width="30%">
            Please enter a description of the item that will be in 
            the WebAuction.
          </td>
          <td>
            <input:text name="description" attributesText='size="30"'/>
            <vtag:validator
              fieldToValidate="description"
              validatorClass="weblogicx.jsp.tags.validators.RequiredFieldValidator"
              errorMessage="Provide a description of the item."/>
              
          </td>
        </tr>

        <tr> 
          <td width="30%">Category</td>
          <td>
            <jsp:scriptlet>
              java.util.Map categoryMap = new java.util.LinkedHashMap();
              categoryMap.put("Books","books");
              categoryMap.put("Clothing","clothing");
              categoryMap.put("Computers","computers");
            </jsp:scriptlet>
            <input:select name="category" options="%= categoryMap %"/>
          </td>
        </tr>

        <tr> 
          <td width="30%">How long should the auction last?</td>
          <td>
            <jsp:scriptlet>
              java.util.Map endTimeMap = new java.util.LinkedHashMap();
              endTimeMap.put("10 minutes","0");
              endTimeMap.put("1 hour","1");
              endTimeMap.put("24 hours","2");
              endTimeMap.put("1 week","3");
            </jsp:scriptlet>
            <input:select name="endTime" options="%= endTimeMap %"/>
          </td>
        </tr>

        <tr> 
          <td>
            <input type="submit" value="Submit" name="Submit"/>
          </td>
        </tr>
      </table>
    </vtag:form>
  </vtag:summary>
</jsp:root>


