<jsp:root
  xmlns:jsp="http://java.sun.com/JSP/Page"
  xmlns:input="http://jakarta.apache.org/taglibs/input-1.0"
  xmlns:vtag="http://www.beasys.com/j2ee/tlds/wl-jspvalidationtaglibrary_1_0.tld"
  xmlns:c="http://java.sun.com/jstl/core"
>

  <jsp:directive.page session="false" errorPage="error.jsp"/>

  <jsp:useBean id="userbean" scope="request" class="webauction.web.javabean.NewUserBean">
    <jsp:setProperty name="userbean" property="userName" />
    <jsp:setProperty name="userbean" property="password" />
    <jsp:setProperty name="userbean" property="firstName" />
    <jsp:setProperty name="userbean" property="lastName" />
    <jsp:setProperty name="userbean" property="streetAddress" />
    <jsp:setProperty name="userbean" property="city" />
    <jsp:setProperty name="userbean" property="zipCode" />
    <jsp:setProperty name="userbean" property="email" />
  </jsp:useBean>

  <vtag:summary name="errorSummary">
    <br/>
    <c:choose>
      <c:when test="${!empty errorSummary}">
        <p>We didn't get all the fields we need. Provide the following fields 
          so that we can create your account:</p>
        <c:forEach var="error" items="${errorSummary}">
          <c:out value="${error}"/><br/>
        </c:forEach>
      </c:when>
      <c:otherwise>
        <p>Please complete the following to register yourself as a 
          user in the WebAuction application.</p>
      </c:otherwise>
    </c:choose>
    <vtag:form method="POST" action="CreateUser">
      <table>
        <tr>
          <td width="30%">Username :</td>
          <td><input:text name="userName" attributesText='size="16"'/>
            <vtag:validator 
              fieldToValidate="userName"
              validatorClass="weblogicx.jsp.tags.validators.RequiredFieldValidator"
              errorMessage="Provide a Username" />
            <vtag:validator 
              fieldToValidate="userName"
              validatorClass="webauction.web.helpers.ValidateUniqueUser"
              errorMessage="Username already exists." />
          </td>
        </tr>

        <tr>
          <td width="30%">Password :</td>
          <td><input type="password" name="password" size="16"/>
            <vtag:validator 
              fieldToValidate="password"
              validatorClass="weblogicx.jsp.tags.validators.RequiredFieldValidator"
              errorMessage="Password" />
            <vtag:validator 
              fieldToValidate="password"
              expression="\S{8,}"
              validatorClass="weblogicx.jsp.tags.validators.RegExpValidator"
              errorMessage="Password must be at least 8 characters long." />
          </td>
        </tr>

        <tr>
          <td width="30%">Confirm Password :</td>
          <td><input type="password" name="password2" size="16"/>
            <vtag:validator 
              fieldToValidate="password,password2"
              validatorClass="weblogicx.jsp.tags.validators.CompareValidator"
              errorMessage="Passwords did not match."/>
          </td>
        </tr>

        <tr>
          <td width="30%">First Name :</td>
          <td><input:text name="firstName" attributesText='size="16"'/>
            <vtag:validator 
              fieldToValidate="firstName"
              validatorClass="weblogicx.jsp.tags.validators.RequiredFieldValidator"
              errorMessage="Firstname" />
          </td>
        </tr>

        <tr>
          <td width="30%">Last Name :</td>
          <td><input:text name="lastName" attributesText='size="16"'/>
            <vtag:validator 
              fieldToValidate="lastName"
              validatorClass="weblogicx.jsp.tags.validators.RequiredFieldValidator"
              errorMessage="Lastname" />
          </td>
        </tr>

        <tr>
          <td width="30%">Street Address :</td>
          <td><input:text name="streetAddress" attributesText='size="16"'/>
            <vtag:validator 
              fieldToValidate="streetAddress"
              validatorClass="weblogicx.jsp.tags.validators.RequiredFieldValidator"
              errorMessage="Address" />
          </td>
        </tr>

        <tr>
          <td width="30%">City :</td>
          <td><input:text name="city" attributesText='size="16"'/>
            <vtag:validator 
              fieldToValidate="city"
              validatorClass="weblogicx.jsp.tags.validators.RequiredFieldValidator"
              errorMessage="City" />
          </td>
        </tr>

        <tr>
          <td width="30%">Zip/Postal Code :</td>
          <td><input:text name="zipCode" attributesText='size="16"'/>
            <vtag:validator 
              fieldToValidate="zipCode"
              expression="\d\d\d\d\d"
              validatorClass="weblogicx.jsp.tags.validators.RegExpValidator"
              errorMessage="Zip/Postal Code must be in the form 99999." />
          </td>
        </tr>

        <tr>
          <td width="30%">Email Address :</td>
          <td><input:text name="email" attributesText='size="16"'/>
            <vtag:validator 
              fieldToValidate="email"
              expression=".*\@.*\..*"
              validatorClass="weblogicx.jsp.tags.validators.RegExpValidator"
              errorMessage="Email Address must be in the form name@host.domain." />
          </td>
        </tr>

        <tr> 
          <td>
            <br/>
            <input type="submit" value="Create New User" name="Create New User"/>
          </td>
        </tr>
      </table>
    </vtag:form>
  </vtag:summary>
</jsp:root>