package webauction.web.helpers;

import java.rmi.RemoteException;

import javax.ejb.CreateException;
import javax.jms.*;
import javax.naming.*;
import javax.rmi.*;
import javax.servlet.*;

import webauction.ejb.*;
import webauction.web.WebConstants;

public class InitializeEjbs implements ServletContextListener {

    public void contextInitialized(ServletContextEvent event) {
        ServletContext sc = event.getServletContext();
        try {
            Context ctx = new InitialContext();

            WebAuctionHome webAuctionHome =
                (WebAuctionHome) PortableRemoteObject.narrow(
                    ctx.lookup(WebConstants.LOOKUP_WEBAUCTION_HOME),
                    WebAuctionHome.class);
            WebAuction webAuction = webAuctionHome.create();

            QueueSender qsender;
            QueueConnectionFactory qconFactory =
                (QueueConnectionFactory) ctx.lookup(WebConstants.SPI_JMS_FACTORY);

            QueueConnection qcon = qconFactory.createQueueConnection();

            QueueSession qsession =
                qcon.createQueueSession(false, Session.AUTO_ACKNOWLEDGE);

            Queue queue = null;

            try {
                queue = (Queue) ctx.lookup(WebConstants.LOOKUP_QUEUE_NAME);
            } catch (NamingException ne) {
                queue = qsession.createQueue(WebConstants.LOOKUP_QUEUE_NAME);
                ctx.bind(WebConstants.LOOKUP_QUEUE_NAME, queue);
            }
            qsender = qsession.createSender(queue);
            qcon.start();

			sc.setAttribute(WebConstants.SC_ATTRIB_CONTEXT, ctx);
			sc.setAttribute(WebConstants.SC_ATTRIB_WEBAUCTION, webAuction);
            sc.setAttribute(WebConstants.SC_ATTRIB_QSESSION, qsession);
            sc.setAttribute(WebConstants.SC_ATTRIB_QSENDER, qsender);
        } catch (NamingException e) {
            e.printStackTrace();
        } catch (RemoteException e) {
            e.printStackTrace();
        } catch (CreateException e) {
            e.printStackTrace();
        } catch (JMSException e) {
            e.printStackTrace();
        }
    }

    public void contextDestroyed(ServletContextEvent arg0) {}
}