package webauction.web.helpers;

import java.rmi.RemoteException;

import javax.ejb.CreateException;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;
import webauction.ejb.*;
import webauction.web.WebConstants;
import weblogicx.jsp.tags.validators.CustomizableAdapter;

public class ValidateUniqueUser extends CustomizableAdapter {

    private String fieldToValidate;
    private Context ctx;
    WebAuction webAuction;
    UserHome userHome;

    public ValidateUniqueUser() {
        super();
        try {
            ctx = new InitialContext();
            WebAuctionHome webAuctionHome =
                (WebAuctionHome) PortableRemoteObject.narrow(
                    ctx.lookup(WebConstants.LOOKUP_WEBAUCTION_HOME),
                    WebAuctionHome.class);
            webAuction = webAuctionHome.create();
            userHome =
                (UserHome) PortableRemoteObject.narrow(
                    ctx.lookup("userHome"),
                    UserHome.class);
        } catch (NamingException e) {
            e.printStackTrace();
        } catch (RemoteException e) {
            e.printStackTrace();
        } catch (CreateException e) {
            e.printStackTrace();
        }
    }

    public boolean validate(javax.servlet.ServletRequest req)
        throws Exception {
        String val = req.getParameter(fieldToValidate);
        if (webAuction.userExists(val)) {
            return false;
        } else {
            return true;
        }
    }

    public void setFieldToValidate(String fieldname) {
        fieldToValidate = fieldname;
    }
}