package webauction.web.taglib;

import javax.servlet.http.HttpServletResponse;
import javax.servlet.jsp.tagext.BodyTagSupport;

public class RewriteHref extends BodyTagSupport {
    private String attributesText;
    private String href;

    public void setAttributesText(String text) {
        this.attributesText = text;
    }

    public void setHref(String href) {
        this.href = href;
    }

    public int doStartTag() {
        return EVAL_BODY_BUFFERED;
    }

    public void doInitBody() {}

    public int doAfterBody() {
        return SKIP_BODY;
    }

    public int doEndTag() {
        javax.servlet.jsp.JspWriter out = getPreviousOut();
        String bodyText = bodyContent.getString();
        HttpServletResponse resp = (HttpServletResponse)pageContext.getResponse();
        
        try {
            out.print("<a href=\"" + href + "\"");
            if (null != attributesText) {
                out.print(" " + attributesText);
            }
            if (null == bodyText) {
                out.print("/>");
            } else {
                out.print(">");
                out.print(bodyText);
                out.print("</a>");
            }
        } catch (java.io.IOException e) {}
        return EVAL_PAGE;
    }

    public void release() {
        href = null;
        attributesText = null;
    }
}
